import * as React from "react";
import Highlighter from "react-highlight-words";
import terms from "./terms.json";
import { KeyTerm } from "./KeyTerm";
import { Text } from "@chakra-ui/react";

export const HighlightKeyTerms = ({ children }: JSX.IntrinsicElements["p"]) => {
  return (
    <Text>
      {React.Children.map(children, (child) => {
        if (typeof child !== "string") {
          return child;
        }

        return (
          <Highlighter
            searchWords={Object.keys(terms)}
            textToHighlight={child}
            highlightTag={({ children }) => (
              <KeyTerm
                term={children}
                definition={terms[children.toLowerCase() as keyof typeof terms]}
              />
            )}
          />
        );
      })}
    </Text>
  );
};
