A declaration prefixed with an `@` character that encapsulates programming logic for query execution on the client or server. GraphQL includes some built-in directives (such as `@skip` and `@include`), and you can define [custom directives](https://www.apollographql.com/docs/apollo-server/v3/schema/creating-directives/). Directives can be used for features such as authentication, incremental data loading, etc.

```graphql
type User @auth {
  name: String!
  banned: Boolean @auth
}
```
